import questionsTemplate from './questions.template.html'

/* @ngInject */
let questionsComponent = {
  template: questionsTemplate,
  bindings: {
    questionsId: '='
  },
  transclude: true,
  controller: function ($scope, $http, $state,$log, $stateParams, $timeout, appConstants, $localStorage, $location) {

    function setupExercise(exerciseData) {
      $scope.exercise = exerciseData
    }

    // Get exercise data and setup
    $scope.$watch('[$ctrl.questionsId]', (n, o) => {
      $scope.loc = $location.absUrl().replace('/' + $scope.location, '').split('/').slice(-1).pop()
      if ($scope.$ctrl.questionsId) {
        $http.get(appConstants.api + '/exercise/' + $scope.$ctrl.questionsId + '/1' , appConstants.http_config)
          .then((response) => {
            $scope.exercise = response.data
            $scope.qid =  $scope.$ctrl.questionsId
            $scope.sid = 1
            $localStorage.$reset()
            $localStorage.exercises = []
            $localStorage.questionCount = $scope.exercise.interaction.questions.length
            $localStorage.questions = $scope.exercise.interaction.questions
            $localStorage.currentActiveExercise = 1
            $localStorage.currentActiveQuestion = $scope.step + 1
            // Assign new data
            $localStorage.playlist = [response.data]
            $localStorage.exerciseCount = $localStorage.playlist.length
            $localStorage.currentExercise = response.data.exercise_id
            $localStorage.currentActiveExercise = 1
          })
      } else if ($stateParams.id && $scope.loc !== 'practice') {
        $http.get(appConstants.api + '/exercise/' + $stateParams.id + '/1' , appConstants.http_config)
          .then((response) => {
            $scope.exercise = response.data
            $scope.qid = $stateParams.id
            $scope.sid = $stateParams.sid
            $localStorage.$reset()
            $localStorage.exercises = []
            $localStorage.questionCount = $scope.exercise.interaction.questions.length
            $localStorage.questions = $scope.exercise.interaction.questions
            $localStorage.currentActiveExercise = 1
            $localStorage.currentActiveQuestion = $scope.step + 1
            // Assign new data
            $localStorage.playlist = [response.data]
            $localStorage.exerciseCount = $localStorage.playlist.length
            $localStorage.currentExercise = response.data.exercise_id
            $localStorage.currentActiveExercise = 1
            $timeout(() => { $state.go('exercise') })
          })
      }
      else { // If we have loaded playlist then load the exercise from playlist
        setupExercise($localStorage.playlist.find((item) => item.exercise_id === $localStorage.currentExercise))
      }
    })
  }

}
export default questionsComponent
